local flux = require "flux"

function love.load()
	me = {x = 100, y = 100, px = 1, py = 1, t = nil, c = 0}
	bad = false
end

function love.update(dt)
	flux.update(dt)
end

local function dotween(dx, dy)
	me.px = me.px+dx me.py = me.py+dy
	if bad then flux.to(me, 0.5, {x = me.x+100*dx, y = me.y+100*dy})
	else
		me.c = me.c + 1
		me.t = me.t == nil and flux.to(me, 0.5, {x = me.px*100, y = me.py*100}):oncomplete(function() me.c = me.c - 1 if me.c == 0 then me.t = nil end end)
			or me.t:after(me, 0.5, {x = me.px*100, y = me.py*100}):oncomplete(function() me.c = me.c - 1 if me.c == 0 then me.t = nil end end)
	end
end

function love.keyreleased(key)
	if key == " " then bad = not bad
	elseif key == "kp1" then dotween(-1,  1)
	elseif key == "kp2" then dotween( 0,  1)
	elseif key == "kp3" then dotween( 1,  1)
	elseif key == "kp4" then dotween(-1,  0)
	elseif key == "kp6" then dotween( 1,  0)
	elseif key == "kp7" then dotween(-1, -1)
	elseif key == "kp8" then dotween( 0, -1)
	elseif key == "kp9" then dotween( 1, -1)
	end
end

function love.draw()
	love.graphics.rectangle("fill", me.x, me.y, 50, 50)
	love.graphics.print("me.x = "..me.x.."\nme.y = "..me.y.."\nme.c = "..me.c.."\nbad = "..tostring(bad), 10, 10)
end
